; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	call LCD_ZEILE1		; ZEILE1
	LDS temp1,(adr_TASTE)
	tst temp1
	breq MENUE_RUN
	call LCD_CLEAR
;-------------------------------------------------------------------------------
MENUE_p:
	LDS temp1,(adr_TASTE)
	cpi temp1,(TASTE_MENUE_PLUS)
	brne MENUE_m
	LDS temp,(adr_MENUE)
	inc temp
	STS(adr_MENUE),temp
;-------------------------------------------------------------------------------
MENUE_m:
	cpi temp1,(TASTE_MENUE_MINUS)
	brne MENUE_RUN
	LDS temp,(adr_MENUE)
	tst temp
	breq MENUE_RUN
	dec temp
	STS(adr_MENUE),temp
;-------------------------------------------------------------------------------
MENUE_RUN:
	ldi ZL, LOW(MENUE_SPRUNGMARKE)	; Z		
	ldi ZH,HIGH(MENUE_SPRUNGMARKE)
	LDS temp,(adr_MENUE)
	LSL temp	; x2, wegen "jmp (2 Words)"	
	add ZL,temp
	adc ZH,NULL
	IJMP	; SPRUNG nach Z
;-------------------------------------------------------------------------------
MENUE_SPRUNGMARKE:
	jmp MENUE_SPUR_READ
	jmp MENUE_MFM1
	jmp MENUE_SPUR_NULL
	jmp MENUE_SPUR_20
	jmp MENUE_SPUR_STEP
	jmp MENUE_SPUR_STEP10
	jmp MENUE_MOTOR_ON_OFF
	jmp MENUE_SELECT_HEAD
	jmp MENUE_SELECT_FLOPPY
	jmp MENUE_FLOPPY_PINS
	jmp MENUE_FLOPPY_STATUS
	jmp MENUE_RPM
	jmp MENUE_IMULSE_PRO_UMDREHUNG
	jmp MENUE_IMULSE_PRO_UMDREHUNG_ALLE_SEKTOREN
	jmp MENUE_SYSTEM
	jmp LCD_ANZEIGE_BEGRUESSUNG
	jmp MENUE_WARNUNG
	jmp MENUE_DATA_WRITE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	STS(adr_MENUE),NULL
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_BAUSTELLE:
	call TEXT_BAUSTELLE
	call LCD_ZEILE2
	call LCD_DOPPEL_PUNKT_SPACE
	LDS temp1,(adr_MENUE)
	call LCD_ZAHL_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SPUR_READ:
	call TEXT_SPUR
	call TEXT_READ
	call LCD_ZEILE2	
	call LCD_ZEILE3	
	call LCD_ANZEIGE_HEAD
	call LCD_ZEILE4
	call LCD_ANZEIGE_SPUR
	call TASTE_PLUS_C
	brcs MENUE_MFM_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_MFM_RUN:
	call LCD_CLEAR
	call TEXT_WAIT
	call WAIT_100ms
	call FLOPPY_SPUR_READ
MENUE_MFM_s:
	call FLOPPY_SLEEP
	call TASTEN_ABFRAGE
	LDS temp,(adr_TASTE)
	tst temp
	breq MENUE_MFM_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_MFM1:
	call TEXT_SEKTOR
	call TEXT_READ
	call LCD_ZEILE2	
	call TEXT_MFM
	call LCD_1
	call LCD_ZEILE3	
	call LCD_ANZEIGE_HEAD
	call LCD_ZEILE4
	call LCD_ANZEIGE_SPUR
	call TASTE_PLUS_C
	brcs MENUE_MFM1_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_MFM1_RUN:
	call LCD_CLEAR
	call TEXT_WAIT
	call MFM1
MENUE_MFM1_s:
	call FLOPPY_SLEEP
	call TASTEN_ABFRAGE
	LDS temp,(adr_TASTE)
	tst temp
	breq MENUE_MFM1_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_MOTOR_ON_OFF:
	call TEXT_MOTOR_ON_OFF
	LDS temp1,(adr_FLOPPY_MOTOR_ON)
	call LCD_ZAHL1_TEMP1
	call TASTE_PLUS_C
	brcs MENUE_MOTOR_ON_OFF_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_MOTOR_ON_OFF_RUN:
	call LCD_CLEAR
	call TEXT_WAIT
	LDS temp,(adr_FLOPPY_MOTOR_ON)
	tst temp
	breq MENUE_MOTOR_ON_OFF_w
	call FLOPPY_MOTOR_OFF
	call LCD_CLEAR
	ret
MENUE_MOTOR_ON_OFF_w:
	call FLOPPY_MOTOR_ON
	call LCD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SELECT_FLOPPY:
	call TEXT_FLOPPY
	LDS temp1,(adr_FLOPPY_SELECT)
	call LCD_ZAHL_TEMP1
	call TASTE_PLUS_C
	brcs MENUE_SELECT_FLOPPY_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SELECT_FLOPPY_RUN:
	call LCD_CLEAR	
	call TEXT_WAIT
	call FLOPPY_MOTOR_OFF
	LDS  temp,(adr_FLOPPY_SELECT)
	inc temp
	andi temp,0b00000001
	STS(adr_FLOPPY_SELECT),temp
	call FLOPPY_MOTOR_ON
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SELECT_HEAD:
	call TEXT_HEAD
	call FLOPPY_SET_HEAD
	call LCD_ZEILE3	
	call LCD_ANZEIGE_HEAD
	call TASTE_PLUS_C
	brcs MENUE_SELECT_HEAD_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SELECT_HEAD_RUN:
	call LCD_CLEAR	
	call TEXT_WAIT
	call WAIT_10ms
	LDS  temp,(adr_FLOPPY_HEAD)
	inc temp
	andi temp,0b00000001
	STS(adr_FLOPPY_HEAD),temp
	call FLOPPY_SET_HEAD
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SPUR_NULL:
	call TEXT_SPUR
	call TEXT_NULL
	call LCD_ZEILE4
	call LCD_ANZEIGE_SPUR
	call TASTE_PLUS_C
	brcs MENUE_SPUR_NULL_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SPUR_NULL_RUN:
	call LCD_CLEAR
	call TEXT_WAIT
	call FLOPPY_SPUR_NULL
	call WAIT_200ms
	call FLOPPY_STEP_PLUS10
	call WAIT_200ms
	call FLOPPY_SPUR_NULL
	call LCD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SPUR_20:
	call TEXT_SPUR
	call LCD_2
	call LCD_0
	call LCD_ZEILE4
	call LCD_ANZEIGE_SPUR
	call TASTE_PLUS_C
	brcs MENUE_SPUR_20_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SPUR_20_RUN:
	call LCD_CLEAR
	call TEXT_WAIT
	call FLOPPY_MOTOR_ON
	call FLOPPY_SPUR_NULL
	call FLOPPY_STEP_PLUS10
	call FLOPPY_STEP_PLUS10
	call LCD_CLEAR
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SPUR_STEP:
	call TEXT_SPUR
	call TEXT_STEP
	call LCD_ZEILE4
	call LCD_ANZEIGE_SPUR
	call TASTE_PLUS_C
	brcs MENUE_SPUR_STEP_P
	call TASTE_MINUS_C
	brcs MENUE_SPUR_STEP_M
	ret
;-------------------------------------------------------------------------------
MENUE_SPUR_STEP_P:
	call LCD_CLEAR
	call TEXT_WAIT
	call FLOPPY_STEP_PLUS
	call LCD_CLEAR
ret
;-------------------------------------------------------------------------------
MENUE_SPUR_STEP_M:
	call LCD_CLEAR
	call TEXT_WAIT
	call FLOPPY_STEP_MINUS
	call LCD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SPUR_STEP10:
	call TEXT_SPUR
	call TEXT_STEP
	call LCD_1
	call LCD_0
	call LCD_ZEILE4
	call LCD_ANZEIGE_SPUR
	call TASTE_PLUS_C
	brcs MENUE_SPUR_STEP10_P
	call TASTE_MINUS_C
	brcs MENUE_SPUR_STEP10_M
	ret
;-------------------------------------------------------------------------------
MENUE_SPUR_STEP10_P:
	jmp FLOPPY_STEP_PLUS10
MENUE_SPUR_STEP10_M:
	jmp FLOPPY_STEP_MINUS10
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_RPM:
	call TEXT_RPM
	call TASTE_PLUS_C
	brcs MENUE_RPM_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_RPM_RUN:
	call LCD_CLEAR
	call TEXT_WAIT
	call FLOPPY_MOTOR_ON
	call FLOPPY_WAIT_INDEX_HIGH
	call FLOPPY_WAIT_INDEX_LOW
	call FLOPPY_WAIT_INDEX_HIGH
	call FLOPPY_WAIT_INDEX_LOW
	call FLOPPY_WAIT_INDEX_HIGH
	call FLOPPY_WAIT_INDEX_LOW
	call FLOPPY_WAIT_INDEX_HIGH
	call UHR_NULL
	clr ZL
	clr ZH
MENUE_RPM_s:
	call FLOPPY_WAIT_INDEX_LOW
	call FLOPPY_WAIT_INDEX_HIGH
	call LCD_ZEILE2		; ZEILE 
	call LCD_ANZEIGE_ZEIT
	call LCD_ZEILE3		; ZEILE 
	adiw ZL,1
	mov temp1,ZL
	mov temp2,ZH
	call LCD_ZAHL_TEMP1_2
	LDS temp,(adr_mm)
	tst temp
	breq MENUE_RPM_s
	call LCD_ZEILE4		; ZEILE 
	call TEXT_FERTIG
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Ergebnis: ca. 75.530...91.000 Imp/min													
MENUE_IMULSE_PRO_UMDREHUNG:
	call TEXT_IMP_PRO_UMDREHUNG
	call TASTE_PLUS_C
	brcs MENUE_IMULSE_PRO_UMDREHUNG_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_IMULSE_PRO_UMDREHUNG_RUN:
	call LCD_CLEAR
	call TEXT_WAIT
	call IMULSE_PRO_UMDREHUNG_TEMP1_2_3_4
	call LCD_ZEILE3		; ZEILE 
	call LCD_ZAHL_TEMP1_2_3_4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
MENUE_IMULSE_PRO_UMDREHUNG_ALLE_SEKTOREN:
	call TEXT_IMP_PRO_UMDREHUNG
	call LCD_ZEILE2
	call TEXT_ALLE
	call TEXT_SEKTOREN
	call TASTE_PLUS_C
	brcs MENUE_IMULSE_ALLE_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_IMULSE_ALLE_RUN:
	call LCD_CLEAR
	call TEXT_WAIT
	STS (adr_FLOPPY_HEAD),NULL
	call FLOPPY_SET_HEAD
	call FLOPPY_SPUR_NULL
	clr R4
	clr R5
	clr R6
	clr R7
	ldi temp9,80
;-------------------------------------------------------------------------------
MENUE_IMULSE_ALLE_s:
	push temp9
	call LCD_ZEILE1		; ZEILE 
	call LCD_ANZEIGE_HEAD
	call LCD_ZEILE2		; ZEILE 
	call LCD_ANZEIGE_SPUR
	call IMULSE_PRO_UMDREHUNG_TEMP1_2_3_4
	mov R0,temp1
	mov R1,temp2
	mov R2,temp3
	mov R3,temp4
	call MENUE_IMP_VERGLEICH
	call LCD_ZEILE3		; ZEILE 
	call LCD_ZAHL_TEMP1_2_3_4
	call LCD_ZEILE4		; ZEILE 
	mov temp1,R4
	mov temp2,R5
	mov temp3,R6
	mov temp4,R7
	call LCD_ZAHL_TEMP1_2_3_4
	call LCD_m_
	call LCD_a_
	call LCD_x_
	pop temp9

	LDS temp,(adr_FLOPPY_HEAD)	; HEAD-Umschaltung	
	inc temp
	andi temp,0b00000001
	STS (adr_FLOPPY_HEAD),temp
	call FLOPPY_SET_HEAD
	LDS temp,(adr_FLOPPY_HEAD)	; Schleife			
	cpi temp,1
	breq  MENUE_IMULSE_ALLE_s
	call FLOPPY_STEP_PLUS		; Spur +1			
	dec temp9
	brne MENUE_IMULSE_ALLE_s	; Schleife			
ret
;-------------------------------------------------------------------------------
; INP: R0...R3
; OUT; R4...R7
MENUE_IMP_VERGLEICH:
	cp R3,R7
	breq MENUE_IMP_w1
	brlo MENUE_IMP_NIX
	brsh MENUE_IMP_g
MENUE_IMP_w1:
	cp R2,R6
	breq MENUE_IMP_w2
	brlo MENUE_IMP_NIX
	brsh MENUE_IMP_g
MENUE_IMP_w2:
	cp R1,R5
	breq MENUE_IMP_w3
	brlo MENUE_IMP_NIX
	brsh MENUE_IMP_g
MENUE_IMP_w3:
	cp R0,R4
	breq MENUE_IMP_NIX
	brlo MENUE_IMP_NIX
	brsh MENUE_IMP_g
MENUE_IMP_NIX:
	ret
MENUE_IMP_g:
	mov R4,R0
	mov R5,R1
	mov R6,R2
	mov R7,R3
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_FLOPPY_STATUS:
	call TEXT_FLOPPY
	call TEXT_STATUS

	call LCD_ZEILE2
	call LCD_T
	call LCD_R
	call LCD_0
	call LCD_0
	call LCD_SPACE
	sbis (TRK00_PIN),(TRK00_PIN_NR)
	call LCD_L
	sbic (TRK00_PIN),(TRK00_PIN_NR)
	call LCD_H


	call LCD_ZEILE3
	call LCD_W
	call LCD_R
	call LCD_P
	call LCD_T
	call LCD_SPACE
	sbis (WRPT_PIN),(WRPT_PIN_NR)
	call LCD_L
	sbic (WRPT_PIN),(WRPT_PIN_NR)
	call LCD_H

	call LCD_ZEILE4
	call LCD_D
	call LCD_s
	call LCD_k
	call LCD_C
	call LCD_SPACE
	sbis (DSKCHG_PIN),(DSKCHG_PIN_NR)
	call LCD_L
	sbic (DSKCHG_PIN),(DSKCHG_PIN_NR)
	call LCD_H

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SYSTEM:
	call TEXT_SYSTEM
	LDS temp1,(adr_FLOPPY_SLEEP)
	call LCD_ZAHL_TEMP1

	call LCD_ZEILE2
	call LCD_S
	call LCD_R
	call LCD_A
	call LCD_M
	call LCD_SPACE
	ldi ZL,low (RAMEND)
	ldi ZH,high(RAMEND)
	ldi XL, LOW (SRAM_START)
	ldi XH, HIGH(SRAM_START)
	sub ZL,XL
	sbc ZH,XH
	mov temp1,ZL
	mov temp2,ZH
	call LCD_ZAHL_TEMP1_2

	call LCD_ZEILE3
	call LCD_D
	call LCD_A
	call LCD_T
	call LCD_A
	call LCD_SPACE
	ldi ZL,low (adr_SRAM_CHECK)
	ldi ZH,high(adr_SRAM_CHECK)
	ldi XL, LOW (adr_DATA)
	ldi XH, HIGH(adr_DATA)
	sub ZL,XL
	sbc ZH,XH
	mov temp1,ZL
	mov temp2,ZH
	call LCD_ZAHL_TEMP1_2

	call LCD_ZEILE4

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_WARNUNG:
	call TEXT_WARNUNG
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_DATA_WRITE:
	call TEXT_DATA
	call TEXT_WRITE
	call LCD_ZEILE2		; ZEILE 	
	call TEXT_WARNUNG
	call TASTE_PLUS_C
	brcs MENUE_DATA_WRITE_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_DATA_WRITE_RUN:
	call TEXT_WAIT
	call FLOPPY_WRITE
	call LCD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_FLOPPY_PINS:
	call TEXT_FLOPPY
	call TEXT_PINS
	call LCD_ZEILE2

	call LCD_ZEILE3
.equ ASCII_L='*'
.equ ASCII_H='-'
;2-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (DENSITY_PIN),(DENSITY_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;4-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (NC0_PIN),(NC0_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;6-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (NC1_PIN),(NC1_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;8-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (INDEX_PIN),(INDEX_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;10-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (MOTENA_PIN),(MOTENA_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;12-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (DRVSB_PIN),(DRVSB_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;14-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (DRVSA_PIN),(DRVSA_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;16-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (MOTENB_PIN),(MOTENB_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP	
;18-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (DIR_PIN),(DIR_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;20-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (STEP_PIN),(STEP_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;---------------------------------------------------------------------------------
	call LCD_SPACE
	call LCD_2
	call LCD_MINUS
	call LCD_2
	call LCD_0
	call LCD_ZEILE4					; Zeile
;22-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (WRDATA_PIN),(WRDATA_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;24-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (WREN_PIN),(WREN_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;26-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (TRK00_PIN),(TRK00_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;28-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (WRPT_PIN),(WRPT_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;30-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (RDDATA_PIN),(RDDATA_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;32-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (HEAD1_PIN),(HEAD1_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;34-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (DSKCHG_PIN),(DSKCHG_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;34-------------------------------------------------------------------------------
	call LCD_SPACE3
	call LCD_2
	call LCD_2
	call LCD_MINUS
	call LCD_3
	call LCD_2
ret





















