; ##############################################################################
; ##############################################################################
; ##############################################################################
; 4 Zellenwerte in einem Byte (komprimiert 4:1)									
MFM4:
	CLI							; INTERRUPTS sperren !!!	
	ldi XL,LOW (adr_DATA)		; DATA						
	ldi XH,HIGH(adr_DATA)		; DATA						
	clr temp1					; Zeitstempel				
	ldi temp9,4					; Bit-Zhler				
;-------------------------------------------------------------------------------
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	call FLOPPY_MOTOR_ON						; Motor on	
	rcall FLOPPY_WAIT_INDEX_HIGH				; Index		
	rcall FLOPPY_WAIT_INDEX_LOW					; Index		
;-------------------------------------------------------------------------------
MFM4_s1:
	sbis (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis DATA-PIN high	
	rjmp MFM4_s1
;-------------------------------------------------------------------------------
MFM4_s2:
	sbic (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis DATA-PIN LOW	
	rjmp MFM4_s2
;-------------------------------------------------------------------------------
	OUT TCNT0,NULL						; Null							
;-------------------------------------------------------------------------------
MFM4_s3:
	sbis (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis DATA-PIN high	
	rjmp MFM4_s3
;-------------------------------------------------------------------------------
MFM4_s4:
	sbic (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis DATA-PIN LOW	
	rjmp MFM4_s4
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
MFM4_RUN:
	in temp1,TCNT0						; Zeitstempel					
	OUT TCNT0,NULL						; Null							
;-------------------------------------------------------------------------------
MFM4_s:
	sbis (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis PIN HIGH		
	rjmp MFM4_s
;-------------------------------------------------------------------------------
	ldi temp2,1							; Zellenwert-1					
	cpi temp1,54
	brlo MFM4_w
	ldi temp2,2							; Zellenwert-2					
	cpi temp1,75	
	brlo MFM4_w
	ldi temp2,3							; Zellenwert-3					
;-------------------------------------------------------------------------------
MFM4_w:
	LSR temp2 		; rechts		
	ROR temp3		; rechts C		
	LSR temp2 		; rechts		
	ROR temp3		; rechts C		
	dec temp9		; Bit-Zhler	
	brne MFM4_e
	ldi temp9,4		; Bit-Zhler	
	ST X+,temp3		; Zeitstempel (neu)		
;-------------------------------------------------------------------------------
MFM4_e:
	sbic (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis PIN LOW	
	rjmp MFM4_e
;-------------------------------------------------------------------------------
	cpi XL,LOW (adr_SRAM_CHECK)
	brne MFM4_RUN
	cpi XH,HIGH(adr_SRAM_CHECK)
	brne MFM4_RUN
;-------------------------------------------------------------------------------
;	call RS232_TX_SRAM							; fr Testzwecke
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an				
	SEI
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN aus		

;	call RS232_TX_SEKTOR

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

