; TASTE "A"										
.equ TASTE_A_PIN_NR			= 0
.equ TASTE_A_PIN			= PIND
.equ TASTE_A_DDR			= DDRD
.equ TASTE_A_PORT			= PORTD
.equ TASTE_MENUE_MINUS		= 1
; TASTE "B"										
.equ TASTE_B_PIN_NR			= 1
.equ TASTE_B_PIN			= PIND
.equ TASTE_B_DDR			= DDRD
.equ TASTE_B_PORT			= PORTD
.equ TASTE_MENUE_PLUS		= 2
; TASTE "C"										
.equ TASTE_C_PIN_NR			= 2
.equ TASTE_C_PIN			= PIND
.equ TASTE_C_DDR			= DDRD
.equ TASTE_C_PORT			= PORTD
.equ TASTE_MINUS			= 4
; TASTE "D"										
.equ TASTE_D_PIN_NR			= 3
.equ TASTE_D_PIN			= PIND
.equ TASTE_D_DDR			= DDRD
.equ TASTE_D_PORT			= PORTD
.equ TASTE_PLUS				= 8

; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_ABFRAGE:
	call WAIT_10us
	clr temp
	cbi (TASTE_A_DDR),(TASTE_A_PIN_NR)	; auf Eingang					
	cbi (TASTE_B_DDR),(TASTE_B_PIN_NR)
	cbi (TASTE_C_DDR),(TASTE_C_PIN_NR)
	cbi (TASTE_D_DDR),(TASTE_D_PIN_NR)
;-------------------------------------------------------------------------------
	sbi (TASTE_A_PORT),(TASTE_A_PIN_NR)	; Pull-Up on					
	sbi (TASTE_B_PORT),(TASTE_B_PIN_NR)
	sbi (TASTE_C_PORT),(TASTE_C_PIN_NR)
	sbi (TASTE_D_PORT),(TASTE_D_PIN_NR)
	call WAIT_10us
;-------------------------------------------------------------------------------
	ldi temp9,255							; Schleife
TASTEN_ABFRAGE_s:
	; Taste "A"gedrckt ?		
	sbis (TASTE_A_PIN),(TASTE_A_PIN_NR)	; springe, wenn BIT(PIN) high	
	SBR temp,(1)
	; Taste "B"gedrckt ?		
	sbis (TASTE_B_PIN),(TASTE_B_PIN_NR)	; springe, wenn BIT(PIN) high	
	SBR temp,(2)
	; Taste "C"gedrckt ?		
	sbis (TASTE_C_PIN),(TASTE_C_PIN_NR)	; springe, wenn BIT(PIN) high	
	SBR temp,(4)
	; Taste "D"gedrckt ?		
	sbis (TASTE_D_PIN),(TASTE_D_PIN_NR)	; springe, wenn BIT(PIN) high	
	SBR temp,(8)
	STS(adr_TASTE),temp
	tst temp
	brne TASTEN_ABFRAGE_w
;-------------------------------------------------------------------------------
	call WAIT_100us
	dec temp9							; Schleife
	brne TASTEN_ABFRAGE_s
;-------------------------------------------------------------------------------
TASTEN_ABFRAGE_w:
	sbi (TASTE_A_DDR),(TASTE_A_PIN_NR)	; auf AUSGANG					
	sbi (TASTE_B_DDR),(TASTE_B_PIN_NR)
	sbi (TASTE_C_DDR),(TASTE_C_PIN_NR)
	sbi (TASTE_D_DDR),(TASTE_D_PIN_NR)
;-------------------------------------------------------------------------------
	cpi temp,(TASTE_MENUE_PLUS)+(TASTE_MENUE_MINUS); RESET ?
	breq TASTE_RESET
;-------------------------------------------------------------------------------
	tst temp							; TASTE ?	
	breq TASTE_NIX
	rcall LCD_CLEAR
	ldi temp,(SLEEPWERT)				; Sleep		
	STS(adr_FLOPPY_SLEEP),temp
TASTE_NIX:
	ret
;-------------------------------------------------------------------------------
TASTE_RESET:
	CLI											; INTERRUPTS sperren	
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  an	
	call LCD_CLEAR
	call TEXT_RESET
	call WAIT_1s	
	jmp RESET
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_WAIT:
	LDS temp,(adr_TASTE)
	tst temp
	brne TASTEN_WAIT_w
	ret
;-------------------------------------------------------------------------------
TASTEN_WAIT_w:
	call WAIT_200ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTE_PLUS_C:
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_PLUS)
	brne TASTE_PLUS_NO
TASTE_PLUS_YES:
	sec 	;Set Carry		
ret
;-------------------------------------------------------------------------------
TASTE_PLUS_NO:
	clc		; Clear Carry	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTE_MINUS_C:
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_MINUS)
	brne TASTE_MINUS_NO
TASTE_MINUS_YES:
	sec 	;Set Carry		
ret
;-------------------------------------------------------------------------------
TASTE_MINUS_NO:
	clc		; Clear Carry	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################



















