;																				
; Warteschleifen																
; Version: 10/2015																
; 22 MHz Takt																	
; 																				
; Hinweis: die Wartezeiten stimmen nur dann, wenn kein Interruptaufruf erfolgt	
;																				
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 1s PAUSE																		
; bei 22 MHZ (22 TAKTE)															
; rcall 4 TAKTE																	
; call  5 TAKTE																	
; ret   5 TAKTE																	
WAIT_1us:	; 5
	WDR		; 1
	NOP		; 2	
	NOP		; 3	
	NOP		; 4	
	NOP		; 5	
	NOP		; 6	
	NOP		; 7	
	NOP		; 8	
	NOP		; 9	
	NOP		; 10
	NOP		; 11
	NOP		; 12
ret			; 5
; ##############################################################################
WAIT_2us:
	rcall WAIT_1us
	rjmp  WAIT_1us
; ##############################################################################
WAIT_3us:
	rcall WAIT_1us
	rcall WAIT_1us
	rjmp  WAIT_1us
; ##############################################################################
WAIT_4us:
	rcall WAIT_2us
	rjmp  WAIT_2us
; ##############################################################################
WAIT_5us:
	rcall WAIT_2us
	rcall WAIT_2us
	rjmp  WAIT_1us
; ##############################################################################
; ##############################################################################
; ##############################################################################
WAIT_10us:
	rcall WAIT_5us 
	rjmp  WAIT_5us 
; ##############################################################################
; ##############################################################################
; ##############################################################################
WAIT_20us:
	rcall WAIT_10us 
	rjmp  WAIT_10us 
; ##############################################################################
; ##############################################################################
; ##############################################################################
WAIT_50us:
	rcall WAIT_20us
	rcall WAIT_20us
	rjmp  WAIT_10us
; ##############################################################################
; ##############################################################################
; ##############################################################################
wait_100us:
	rcall WAIT_50us
	rjmp  WAIT_50us
; ##############################################################################
; ##############################################################################
; ##############################################################################
wait_200us:  			
	rcall wait_100us
	rjmp  wait_100us
; ##############################################################################
; ##############################################################################
; ##############################################################################
wait_500us:  		
	WDR
	rcall wait_200us	
	rcall wait_200us
	rjmp  wait_100us
; ##############################################################################
; ##############################################################################
; ##############################################################################
wait_1ms:                               
	rcall wait_500us
	rjmp  wait_500us
; ##############################################################################
; ##############################################################################
; ##############################################################################
wait_2ms:                               
	rcall wait_1ms
	rjmp  wait_1ms
; ##############################################################################
; ##############################################################################
; ##############################################################################
wait_5ms:                               
	rcall wait_2ms
	rcall wait_2ms
	rjmp  wait_1ms
; ##############################################################################
; ##############################################################################
; ##############################################################################
wait_10ms:                               
	rcall wait_5ms
	rjmp  wait_5ms
; ##############################################################################
; ##############################################################################
; ##############################################################################
wait_20ms:                               
	rcall wait_10ms
	rjmp  wait_10ms
; ##############################################################################
; ##############################################################################
; ##############################################################################
wait_50ms:                               
	rcall wait_20ms
	rcall wait_20ms
	rjmp  wait_10ms
; ##############################################################################
; ##############################################################################
; ##############################################################################
WAIT_100ms:
	rcall wait_50ms
	rjmp  wait_50ms
; ##############################################################################
; ##############################################################################
; ##############################################################################
wait_200ms:                               
	rcall WAIT_100ms
	rjmp  WAIT_100ms
; ##############################################################################
; ##############################################################################
; ##############################################################################
wait_500ms:                               
	rcall WAIT_200ms
	rcall WAIT_200ms
	rjmp  WAIT_100ms
; ##############################################################################
; ##############################################################################
; ##############################################################################
WAIT_1s:
	rcall WAIT_500ms
	rjmp  WAIT_500ms
; ##############################################################################
WAIT_2s:
	rcall WAIT_1s
	rjmp  WAIT_1s
; ##############################################################################
WAIT_5s:
	rcall WAIT_2s
	rcall WAIT_2s
	rjmp  WAIT_1s
; ##############################################################################
WAIT_10s:
	rcall WAIT_5s
	rjmp  WAIT_5s
